Subject: Re: bug#49168: ‘guix importpypi’ misses package dependencies

From: Leo Prikler <[email-masked]>
Date: Wed, 23 Jun 2021 16:17:11 +0200

Am Mittwoch, den 23.06.2021, 15:20 +0200 schrieb Ludovic Courtès:
> Hi,
> 
> Leo Prikler <[email-masked]> skribis:
> 
> > Am Dienstag, den 22.06.2021, 14:33 +0200 schrieb Ludovic Courtès:
> 
> [...]
> 
> > > Actually
> > > <
> > > https://files.pythonhosted.org/packages/fe/9d/4e15b2e74044ee051b6939c1b3ff716b0106e8f72d78eab8e08212eab44c/tablib-3.0.0.tar.gz
> > > does not have a ‘requirements.txt’ file, and
> > > <
> > > https://files.pythonhosted.org/packages/16/85/078fc037b15aa1120d6a0287ec9d092d93d632ab01a0e7a3e69b4733da5e/tablib-3.0.0-py3-none-any.whl
> > > doesn’t have much metadata, so I don’t even get where were get
> > > that
> > > info.
> > It does, but it's well hidden in the src tree.  I peeked into the
> > guix
> > import code to find it.
> 
> Indeed.  The tarball above has ‘tests/requirements.txt’:
> 
> --8<---------------cut here---------------start------------->8---
> pytest
> pytest-cov
> MarkupPy
> odfpy
> openpyxl>=2.6.0
> pandas
> pyyaml
> tabulate
> xlrd
> xlwt
> --8<---------------cut here---------------end--------------->8---
> 
> There are no optional dependencies in that file, though.  Or were you
> looking at something else?
The importer and I are looking at something else:

--8<---------------cut here---------------start------------->8---
$ tar xfv tablib-3.0.0.tar.gz tablib-3.0.0/src/tablib.egg-
info/requires.txt | xargs cat

[all]
markuppy
odfpy
openpyxl>=2.6.0
pandas
pyyaml
tabulate
xlrd
xlwt

[cli]
tabulate

[html]
markuppy

[ods]
odfpy

[pandas]
pandas

[xls]
xlrd
xlwt

[xlsx]
openpyxl>=2.6.0

[yaml]
pyyaml
--8<---------------cut here---------------end--------------->8---

> > > As for emitting comments, the (not-so-) pretty printer written
> > > for
> > > ‘guix
> > > style’¹ could come in handy for importers and more generally in
> > > any
> > > place where we need to emit comments.
> > Indeed, I wasn't thinking about that when I wrote this reply, but I
> > see
> > what you mean.  Should we strive to have such a pretty-printer in
> > Guile
> > as well or do we keep it to ourselves for now? :)
> 
> Let’s nurture it in Guix and move it to Guile when it looks better.
> Likewise, we should have support for comments directly in (ice-9
> read).
Sounds good to me.